{#
 # This file is part of the DATAtourisme project.
 # @author Conjecto <contact@conjecto.com>
 # 2022
 # SPDX-License-Identifier: GPL-3.0-or-later
 # For the full copyright and license information, please view the LICENSE file that was distributed with this source code.
 #}

{% extends "_layout.html.twig" %}
{% set _breadcrumb = term.breadcrumb  %}
{% set showSubmit = false  %}

{% macro thesaurus_menu(menu, type, currentClass) %}
    {% import _self as self %}

    <ul class="nav nav-pills nav-stacked">
        {% for class, info in menu %}
            {% if info.nbrChild > 0 %}
                <li {% if class == currentClass %}class="active"{% endif %}>
                    <a href="{{ path('thesaurus.align', {'rdfClass': class, 'type': type}|merge(app.request.query)) }}" title="{{ class }}">{{ info['label'] }}
                        <span class="label label-default pull-right">{{ info.nbrChild }}</span></a>
                    {% if info.hierarchy is defined %}
                        {{ self.thesaurus_menu(info.hierarchy, type, currentClass) }}
                    {% endif %}
                </li>
            {% elseif app.environment == 'dev' and type != 'geographic' %}
                <li>
                    <a class="disabled alert-danger" title="{{ class }}">{{ info['label'] }}</a>
                </li>
            {% endif %}
        {% endfor %}
    </ul>
{% endmacro %}

{% from _self import thesaurus_menu %}

{% block content %}
    <!-- Content Header (Page header) -->
    <section class="content-header">
        <div class="pull-right">
            {% if term.type != 'geographic' %}
                {% if app.request.query.get('expand') is not empty %}
                    <a href="{{ path(app.request.get('_route'), app.request.get('_route_params')|merge(app.request.query)|merge({expand: null})) }}" class="btn m-r-5 btn-primary btn-white"><i class="fa fa-compress"></i> Cacher les enfants</a>
                {% else %}
                    <a href="{{ path(app.request.get('_route'), app.request.get('_route_params')|merge(app.request.query)|merge({expand: 1})) }}" class="btn m-r-5 btn-primary btn-white"><i class="fa fa-expand"></i> Afficher les enfants</a>
                {% endif %}
            {% endif %}
            <div class="btn-group">
                <button type="button" class="btn btn-primary dropdown-toggle" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                    <span class="fa fa-cog"></span> Importer/exporter <span class="caret"></span>
                </button>
                <ul class="dropdown-menu">
                    <li><a href="{{ path('thesaurus.export', {'type': term.type, 'rdfClass': term.currentClass, 'allExport': 0}) }}"><span class="fa fa-upload "></span> Exporter les correspondances pour &laquo; {{ term.name }} &raquo;</a></li>
                    <li><a href="{{ path('thesaurus.export', {'type': term.type, 'rdfClass': term.currentClass, 'allExport': 1}) }}"><span class="fa fa-upload "></span> Exporter toutes les correspondances</a></li>
                    <li><a href="{{ path('thesaurus.import', {'type': term.type, 'rdfClass': term.currentClass}) }}" data-toggle="modal-remote"><span class="fa fa-download"></span> Importer des correspondances</a></li>
                </ul>
            </div>
        </div>
        <h1>
            Thésaurus
            <small>{{ term.name }}</small>
        </h1>
    </section>

    <section class="content thesaurus">
        <div class="row">
            <div class="col-md-4">
                <div class="box box-solid" >
                    <div class="box-body no-padding">
                        {{ thesaurus_menu(term.menu, term.type, term.currentClass) }}
                    </div>
                    <!-- /.box-body -->
                </div>
                <!-- /.box -->
            </div>

            <!-- /.col -->
            <div class="col-md-8">
                {{ form_start(form, {attr: {class: 'dirty-form'}}) }}

                {% for item in form.children %}
                    <div class="box box-default">
                        <div class="box-header with-border">
                            <h3 class="box-title">{{ item.vars.label }}</h3>
                            <ol class="breadcrumb">
                                {% for path in item.vars.breadcrumb %}
                                    {% set label = path is iterable ? path[0] : path %}
                                    {% set currentRoute = path is iterable ? path[1] : null %}
                                    {% set args = path is iterable and path[2] is defined ? path[2] : [] %}
                                    {% if loop.last %}
                                        <li><a class="active">{{ label }}</a></li>
                                    {% else %}
                                        <li><a href="{{ currentRoute ? path(currentRoute, args|merge(app.request.query)) : '#' }}">{{ label }}</a></li>
                                    {% endif %}
                                {% endfor %}
                            </ol>
                            <!-- /.box-tools -->
                        </div>

                        <!-- if form has only token field -->
                        {% if item.children | length > 0 %}
                            {% set showSubmit = true %}
                            <!-- /.box-header -->
                            <div class="box-body no-padding">
                                <div class="table-responsive mailbox-messages">
                                    <table class="table table-striped">
                                        <thead><tr>
                                            <th>Classe</th>
                                            <th width="100%">Correspondances</th>
                                        </tr></thead>
                                        <tbody>
                                            {% for child in item.children %}
                                                <tr>
                                                    {% if child.vars.attr.isClickable == 1 %}
                                                        <td style="white-space: nowrap" title="{{ child.vars.attr.shortIri }}"><a href="{{ path('thesaurus.align', {type: item.vars.type, rdfClass: child.vars.attr.shortIri}|merge(app.request.query)) }}">{{ child.vars.label }}</a></td>
                                                    {% else %}
                                                        <td style="white-space: nowrap" title="{{ child.vars.attr.shortIri }}">{{ child.vars.label }}</td>
                                                    {% endif %}
                                                    <td>{{ form_widget(child) }}</td>
                                                </tr>
                                            {% endfor %}
                                        </tbody>
                                    </table>
                                    <!-- /.table -->
                                </div>
                                <!-- /.mail-box-messages -->
                            </div>
                        {% else %}
                            <div class="box-body">
                                <div class="blankslate blankslate-spacious">
                                    <h3>Il n'y a aucun terme directement rattaché à <strong>{{ item.vars.label }}</strong>.</h3>
                                    <p>Utilisez le menu de navigation pour consulter les sous-types</p>
                                    {{ form_widget(item) }}
                                </div>
                            </div>
                        {% endif %}
                    </div>
                {% endfor %}

                <!-- /.box-body -->
                {% if showSubmit %}
                <div class="box box-solid">
                    <div class="box-footer no-padding">
                        <div class="mailbox-controls">
                            <!-- Check all button -->
                            <button type="submit" class="btn btn-primary">Sauvegarder</button>
                            <!-- /.pull-right -->
                        </div>
                    </div>
                </div>
                {% endif %}

                {{ form_end(form) }}
                <!-- /. box -->
            </div>
        <!-- /.row -->
        </div>
    </section>
{% endblock %}
